/*
 * Soya3D
 * Copyright (C) 1999-2000 Jean-Baptiste LAMY (Artiste on the web)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package opale.soya.soya3d.event;

import java.beans.*;

/**
 * A property change event that is also a move-event. Such an event is fired when the position
 * has changed.
 * 
 * See soya.soya3D.event.MoveEvent .
 * 
 * @author Artiste on the Web
 */

public class PropertyChangeMoveEvent extends PropertyChangeEvent implements MoveEvent {
  public PropertyChangeMoveEvent(Object source) {
    super(source, "position", null, null);
  }
  public PropertyChangeMoveEvent(Object source, String propertyname) {
    super(source, propertyname, null, null);
  }
  public PropertyChangeMoveEvent(Object source, String propertyname, Object oldValue, Object newValue) {
    super(source, propertyname, oldValue, newValue);
  }
}
